#!/bin/bash

# Set the hostnames
sudo bash -c "echo '127.0.0.1 node0.gfs node0 localhost' > /etc/hosts"
sudo bash -c "echo '192.168.255.2 node0.gfs node0' >> /etc/hosts"
sudo bash -c "echo '192.168.255.3 node1.gfs node1' >> /etc/hosts"
sudo bash -c "echo 'node0.gfs' > /etc/hostname"
sudo hostname node0.gfs

# Insert our crap RSA key
cat > ~/.ssh/gluster_rsa << EOF
-----BEGIN RSA PRIVATE KEY-----
MIICXQIBAAKBgQC9OHXn1tk9qlQ/PNQ94DiNP0nBziAJ2kQwPPk7hVpKFAcalYF8
kNAp8XgSWYezH6amckqw02KL2vuQlh83mQ2QfRjCQ9gp7jtXqNBN7mwNeOYfJVUg
pp7tUuG7K+zMN9e6hea1v5XTUEZAfLsPwJBBLwlZCDdwGSMy00t20Iq/awIDAQAB
AoGBALFbXoh0BSObp2OurHFi3R7nl0ak4brabteYDzQPBlYw94efYsNTKQpnXtg0
OtFWdWnF7uRW/iOAmhMn4xLFzsNm7P8Q47j2igCbilhdZQKG4h19AR3+UsR06mMb
n3PAWc7hHLewDemaPIO/RJ4fWUTiUL4m3yULjcp5zmggJTLBAkEA43jSPwtFzZyD
5TJKGSQJ/a99D5SdobZ6gBCDp7cQxsBpsSyU/GO6uInlwEST22loBppcxVS2Drfw
WzIvXMemOQJBANTzi6y0cf7mxzSLLai3hN+p53PCbtnUapcCqOWaAR9ztCNgn7Ni
zHXnVoC/6L/2tF6BBTKtVVOSSsoC1VYAMsMCQBG8e/g6csjjaU1XrHtlWfoT0taC
KgBP8CFIKFvNZFt66ULNTRiY1hhJeEaTkkvLXjcVliI0xrVDFlSmBxde4dECQCWi
PObypMrFgiL5DcKpXCQi5LKChBCfB49UewDIrLYgPo+Z/d838KZNke4C/GEgelPR
PVftZgz05563zXf7ZP0CQQDFpw2urfvgBqmb/IHFCdDd/2ZOmn0c6FeOLe4OgLKz
wp31+FrphnGJ9AKvRGFToBAMyrPRt1irILBcAH2cZlJX
-----END RSA PRIVATE KEY-----
EOF
cat >> ~/.ssh/authorized_keys << EOF
ssh-rsa AAAAB3NzaC1yc2EAAAADAQABAAAAgQC9OHXn1tk9qlQ/PNQ94DiNP0nBziAJ2kQwPPk7hVpKFAcalYF8kNAp8XgSWYezH6amckqw02KL2vuQlh83mQ2QfRjCQ9gp7jtXqNBN7mwNeOYfJVUgpp7tUuG7K+zMN9e6hea1v5XTUEZAfLsPwJBBLwlZCDdwGSMy00t20Iq/aw== glusterfs
EOF

chmod 0600 ~/.ssh/gluster_rsa ~/.ssh/authorized_keys


# Insert out .ssh/config file
cat > ~/.ssh/config << EOF
Host node0.gfs
	HostName node0.gfs
	User root
	IdentityFile ~/.ssh/gluster_rsa
Host node1.gfs
	HostName node1.gfs
	User root
	IdentityFile ~/.ssh/gluster_rsa
EOF

# Update repository, upgrade all files.
sudo apt-get update
sudo apt-get upgrade -y

# Install XFS
sudo apt-get install -y xfsprogs

# Set up our nice new disk
sudo bash -c "echo -e 'o\nn\np\n1\n\n\nw' | fdisk /dev/sdb"
sudo mkfs.xfs -i size=512 /dev/sdb1
sudo mkdir -p /data/brick1
sudo bash -c "echo '/dev/sdb1 /data/brick1 xfs defaults 1 2' >> /etc/fstab"
sudo mount -a && sudo mount

# Install ndp and Gluster
sudo apt-get install -y ntp glusterfs-server

# Create our GFS volume.
sudo mkdir /data/brick1/gv0

# Tell us the IP
echo " "
IP=$(ip addr | grep eth1 | grep inet | awk '{ print $2 }' | sed -e 's/\/24//')
echo "Your IP is: $IP"
